/*
 * bippoess.h
 *
 *  Copyright (C) 2008, Thomas Hamelryck, The Bioinformatics Centre, 
 *  University of Copenhagen.
 *
 *  This file is part of Mocapy++.
 *
 *  Mocapy++ is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Mocapy++ is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Mocapy++.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef BIPPOESS_H_
#define BIPPOESS_H_

#include "../framework/essbase.h"

namespace mocapy {
// Indices for the ess vector
// counts, sums for first, second, and third moment, nr of data points
enum BIPPO_ESS_INDEX {BP_N, BP_S, BP_S2, BP_S3, BP_ESSSIZE};

class BippoESS: public ESSBase {
public:
	BippoESS() {};
	virtual ~BippoESS() {};

	// Initializes the ESS arrays.
	void construct(vector<uint> & parent_sizes, uint output_dim, 
        uint node_size);

	// Add another sample to the ESS
	void add_ptv(vector<double> ptv);
};
}
#endif /* BIPPOESS_H_ */
