/*
 * randomgen.cpp
 *
 *  Copyright (C) 2008, Martin Paluszewski, The Bioinformatics Centre, University of Copenhagen.
 *
 *  This file is part of Mocapy++.
 *
 *  Mocapy++ is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Mocapy++ is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Mocapy++.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "randomgen.h"

namespace mocapy {

// Initialize the random number generators that are used by Mocapy.
void RandomGen::mocapy_seed(uint s) {
  //	srand(s);
	moc_seed1 = s;
	moc_seed2 = s;
	rng.seed(moc_seed1);
}

double RandomGen::get_rand() {
  assert(r);

	// Mersenne Twister
  double x = (*r)();
	return x;

	// Using C standard rand()
//	return ((double) rand()) / ((double) (RAND_MAX + 1.0));
}

double RandomGen::get_rand_normal() {
     double x = (*norm)();
     return x;
}
}
